"""

Part of the tagit module.
A copy of the license is provided with the project.
Author: Matthias Baumgartner, 2017
"""
# imports

# inner-module imports
from feature import Feature

# exports
__all__ = ('TagLifetime', )


## code ##

class TagLifetime(Feature):

    def first_addition(self, tag): # First addition of tag
        # tag.t_created
        raise NotImplementedError()

    def last_addition(self, tag): # Last addition of tag
        # max(img_tag.t_created where tag = ?)
        raise NotImplementedError()

    def recent_timespan(self, tag): # Timespan betwen latest N additions
        # span((img_tag.t_created where tag = ? order by t_created desc)[:N])
        raise NotImplementedError()

    def lifespan(self, tag): # Timespan between last and first addition
        # max(img_tag.t_created where tag = ?) - tag.t_created
        raise NotImplementedError()

    def recent_additions(self, tag): # Number of additions in last N seconds
        # count(*) from img_tag where tag = ? and t_created >= N
        raise NotImplementedError()


## EOF ##
