"""

TODO: File is unused, remove or use!!

Part of the tagit module.
A copy of the license is provided with the project.
Author: Matthias Baumgartner, 2017

"""
# imports

# inner-module imports
from tagit.external.memoize import memoized

# exports
__all__ = ('ALL_METRICS', )

## code ##

def levenshtein(tag):
    """Levenshtein distance of *tag* to any other in the database.
    """
    raise NotImplementedError()

# fu(model, candidates, tag) -> score (float)
ALL_METRICS = [
    #(1.0, lambda m,c,t: len(t)), # shortest tags first
    #(1.0, lambda m,c,t: max(map(len, c)) - len(t)), # longest tags first
    (1.0, lambda m,c,t: sorted(c).index(t)), # alphabethical order
    #(1.0, levenshtein)
]

class Aggregators(object):
    sum = sum
    min = min
    max = max

    @staticmethod
    def mean(lst):
        return 1.0 * sum(lst) / len(lst)

    @staticmethod
    def median(lst):
        # from: https://stackoverflow.com/questions/10482339/how-to-find-median
        even = (0 if len(lst) % 2 else 1) + 1
        half = (len(lst) - 1) / 2
        return sum(sorted(lst)[half:half + even]) / float(even)

    @staticmethod
    def abssum(lst):
        return 1.0 * sum(map(abs, lst))

    @staticmethod
    def sum_of_squares(lst):
        square = lambda i: i*i
        return 1.0 * sum(map(square, lst))

class SetMetrics(object):

    @staticmethod
    def mutual_information(setA, setB):
        pass

    @staticmethod
    def correlation(setA, setB):
        pass

    @staticmethod
    def levenshtein(setA, setB):
        pass

    @staticmethod
    def tversky(setA, setB):
        pass

    @staticmethod
    def cosine(setA, setB):
        pass

    @staticmethod
    def is_subset(self, tagA, tagB):
        all(tagB in img for img in tagA)
        pass

    @staticmethod
    def is_superset(self, tag):
        pass

## EOF ##
