"""

Part of the tagit module.
A copy of the license is provided with the project.
Author: Matthias Baumgartner, 2016

"""
# STANDARD IMPORTS

# INNER-MODULE IMPORTS
from updater import Updater

# EXPORTS
__all__ = ('Update_3', )

## CODE ##

class Updater_3(Updater):
    SQL = '''
-- Change tables
ALTER TABLE tag ADD COLUMN t_created INTEGER unsigned DEFAULT 0;
ALTER TABLE img_tag ADD COLUMN t_created INTEGER unsigned DEFAULT 0;

UPDATE tag SET t_created = 0;
UPDATE img_tag SET t_created = 0;

-- Update version
PRAGMA user_version = 3;

-- EOF --
'''

## EOF ##
