"""

Part of the tagit module.
A copy of the license is provided with the project.
Author: Matthias Baumgartner, 2016

"""
# STANDARD IMPORTS

# INNER-MODULE IMPORTS
from updater import Updater

# EXPORTS
__all__ = ('Update_4', )

## CODE ##

class Updater_4(Updater):
    SQL = '''

-- create new tables
CREATE TABLE search_history (
    id INTEGER PRIMARY KEY,
    t_logged INTEGER unsigned DEFAULT 0
);

CREATE TABLE search_token (
    id INTEGER PRIMARY KEY,
    search INTEGER NOT NULL,
    active INTEGER default 1,
    token TEXT,
    FOREIGN KEY(search) REFERENCES search_history(id) ON DELETE CASCADE
);

-- Update version
PRAGMA user_version = 4;

-- EOF --
'''

## EOF ##
